package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmAgriculturalProductSupervisionCheck;
import com.zksy.system.basicData.service.CrmAgriculturalProductSupervisionCheckService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 食品及食用农产品监督抽检情况汇总Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmAgriculturalProductSupervisionCheck")
@Api(tags = "食品及食用农产品监督抽检情况汇总", description = "食品及食用农产品监督抽检情况汇总desc")
public class CrmAgriculturalProductSupervisionCheckController extends BaseController {

    @Autowired
    private CrmAgriculturalProductSupervisionCheckService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "食品及食用农产品监督抽检情况汇总搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "食品及食用农产品监督抽检情况汇总分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "食品及食用农产品监督抽检情况汇总查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增食品及食用农产品监督抽检情况汇总
     */
    @PostMapping("/save")
    @ApiOperation(value = "食品及食用农产品监督抽检情况汇总新增")
    @Log(title = "新增食品及食用农产品监督抽检情况汇总", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmAgriculturalProductSupervisionCheck crmAgriculturalProductSupervisionCheck) {
        return service.save(crmAgriculturalProductSupervisionCheck);
    }

    /**
     * 修改食品及食用农产品监督抽检情况汇总
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "食品及食用农产品监督抽检情况汇总修改")
    @Log(title = "修改食品及食用农产品监督抽检情况汇总", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmAgriculturalProductSupervisionCheck crmAgriculturalProductSupervisionCheck) {
        return service.updateById(crmAgriculturalProductSupervisionCheck);
    }

    /**
     * 导入食品及食用农产品监督抽检情况汇总
     */
    @ApiOperation("食品及食用农产品监督抽检情况汇总导入")
    @Log(title = "食品及食用农产品监督抽检情况汇总", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmAgriculturalProductSupervisionCheck> crmAgriculturalProductSupervisionCheckAll = service.list();
            List<CrmAgriculturalProductSupervisionCheck> list = ExcelUtils.readMultipartFile(file, CrmAgriculturalProductSupervisionCheck.class,CrmAgriculturalProductSupervisionCheck.class.getDeclaredFields().length - 2);
            if(crmAgriculturalProductSupervisionCheckAll != null && crmAgriculturalProductSupervisionCheckAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("食品及食用农产品监督抽检情况汇总导出")
    @Log(title = "食品及食用农产品监督抽检情况汇总", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmAgriculturalProductSupervisionCheck> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"食品及食用农产品监督抽检情况汇总",wrapperList,CrmAgriculturalProductSupervisionCheck.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "食品及食用农产品监督抽检情况汇总", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除食品及食用农产品监督抽检情况汇总", notes = "删除食品及食用农产品监督抽检情况汇总")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"食品及食用农产品监督抽检情况汇总模板");
    }
}

